
    <!DOCTYPE html>
    <html>
      <body>
        <style>@page {
  size: 1280px 720px;
  margin: 0;
}@media print {html, body {
  background-color: #fff;
  margin: 0;
  page-break-inside: avoid;
  break-inside: avoid-page;
}
  div.marpit > section {
    page-break-before: always;
    break-before: page;
  }

  div.marpit > section, div.marpit > section * {
    -webkit-print-color-adjust: exact !important;
    animation-delay: 0s !important;
    animation-duration: 0s !important;
    color-adjust: exact !important;
    transition: none !important;
  }

  div.marpit > svg[data-marpit-svg] {
    display: block;
    height: 100vh;
    width: 100vw;
  }
}

div.marpit > section {
  width: 1280px;
  height: 720px;

  box-sizing: border-box;
  overflow: hidden;
  position: relative;

  scroll-snap-align: center center;
}

div.marpit > section::after {
  bottom: 0;
  content: attr(data-marpit-pagination);
  padding: inherit;
  pointer-events: none;
  position: absolute;
  right: 0;
}

div.marpit > section:not([data-marpit-pagination])::after {
  display: none;
}

/* Normalization */
div.marpit > section h1 {
  font-size: 2em;
  margin: 0.67em 0;
}

div.marpit > section video::-webkit-media-controls {
  will-change: transform;
}</style>
        <div class="marpit"><section id="1" data-marpit-fragments="15">
<h1>Мониторинг</h1>
<p>В этой домашней работе мы подключим Datadog к нашим серверам Digital Ocean и настроим монитор, который будет проверять доступность нашего приложения, и, в случае отклонения от нормы, посылать уведомление об этом по электронной почте.</p>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="1"><a href="https://www.datadoghq.com/">Datadog</a></li>
<li data-marpit-fragment="2"><a href="https://docs.datadoghq.com/integrations/http_check/">HTTP Check</a> - монитор состояния приложения, который мы будем устанавливает. Опрашивает определенный адрес каждые N секунд</li>
<li data-marpit-fragment="3"><a href="https://docs.datadoghq.com/monitors/">Alerting</a> - Документация Datadog по алертам и мониторам</li>
<li data-marpit-fragment="4"><a href="https://galaxy.ansible.com/DataDog/datadog">https://galaxy.ansible.com/DataDog/datadog</a> - роль Ansible Galaxy для установки Datadog</li>
<li data-marpit-fragment="5"><a href="https://docs.ansible.com/ansible/latest/galaxy/user_guide.html#installing-roles-and-collections-from-the-same-requirements-yml-file">Installing roles and collections from the same requirements.yml file</a> - документация Ansible по работе с зависимостями</li>
</ul>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="6">
<p>Зарегистрируйтесь на <a href="https://app.datadoghq.com/signup">datadoghq.com</a></p>
</li>
<li data-marpit-fragment="7">
<p>На шаге <em>3. Agent Setup</em>. Выберите Ansible в качестве способа установки.</p>
</li>
<li data-marpit-fragment="8">
<p>Добавьте в роль <code>datadog.datadog</code> в <em>requirements.yml</em>.</p>
</li>
<li data-marpit-fragment="9">
<p>Добавьте роль <code>datadog.datadog</code> в плейбук. Добавьте переменные из шага в плейбук. Зашифруйте ключ апи с помощью Ansible Vault.</p>
</li>
<li data-marpit-fragment="10">
<p>В качестве проверки состояния приложения будет использовать <a href="https://docs.datadoghq.com/integrations/http_check/">http_check</a> Он добавляется с помощью переменных в плейбуке. Агент будет проверять, что наше приложение запущено на 5000 порту:</p>
<pre><code class="language-yaml">http_check:
    init_config:
    instances:
        - name: Application health check status
            url: http://localhost:5000
            timeout: 5
            method: GET
</code></pre>
</li>
<li data-marpit-fragment="11">
<p>Если агент настроен правильно, то через 2-3 минуты информация будет отправлена в Datadog. Создайте новый монитор в разделе Network. Выберите созданный <em>http_check</em>, далее вам необходимо выбрать все хосты, сколько проверок требуется для оповещения и восстановления.</p>
</li>
<li data-marpit-fragment="12">
<p>В сообщении оповещения сделайте заголовок <em>Hexlet HTTP Alert! &lt;host_name&gt;</em>, где host_name - это переменная, которая будет подставляться из переменных Datadog.</p>
</li>
<li data-marpit-fragment="13">
<p>Добавьте себя в оповещение. Проверьте, что оповещение настроено корректно, отправьте тестовое сообщение с помощью соответствующей кнопки.</p>
</li>
<li data-marpit-fragment="14">
<p>Зайдите на один из серверов и остановите контейнер приложения. Если все было настроено правильно, то придет оповещение от Datadog о недоступности сервиса.</p>
</li>
</ul>
<p>После выполнения домашней работы в issuе приложите скриншоты:</p>
<ol>
<li>Запущенный монитор HTTP</li>
</ol>
<p><img src="assets/monitor.png" alt="" /></p>
<ol start="2">
<li>Сработавший алерт монитора</li>
</ol>
<p><img src="assets/alert.png" alt="" /></p>
<ol start="3">
<li>Тело письма оповещения</li>
</ol>
<p><img src="assets/alert-notification.png" alt="" /></p>
<h2>Подсказки</h2>
<ul>
<li data-marpit-fragment="15">Чтобы агент Datadog запускался после приложения, используйте <a href="https://docs.ansible.com/ansible/latest/collections/ansible/builtin/include_role_module.html">ansible.builtin.include_role</a></li>
</ul>
<h2>Дополнительное задание</h2>
<p>Настройте дашборд и выведите текущие метрики сервера.</p>
</section>
</div>
      </body>
    </html>
  